var scatMemoryMgr  = [];

/**
 * Resize content panel based on screen size
 */
function resizeContentPanel() {
    var el = Ext.get('topHeader');
    if (el) {
        var size = el.dom.offsetWidth;
        var curTab = Ext.get('currentTab');
        if (curTab.dom.innerHTML === '')
            return false;

        if (curTab.dom.innerHTML === 'tabImpact'){
            return resizeTabImpactContent(size);
        }


        var div = Ext.get(curTab.dom.innerHTML + 'Content');
        if (Ext.isIE) {
            div.setWidth(size);
            div.dom.style.width = size;
        } else {
            div.setWidth(size-44);
            div.dom.style.width = size-44;
        }

        // Firefox 2 compatibility
        if (Ext.isGecko2) {
            div.dom.style.zIndex = 0;
            var panel = Ext.get('tabPanelMenu');
            panel.dom.style.zIndex = 1;
            panel.dom.style.position = 'relative';
        }

    }
}

function resizeTabImpactContent(width){
     Ext.get('tabImpactContent').setWidth(width);
     Ext.query('.inpactPanel').forEach(function(element){
         Ext.getCmp(element.id).setWidth(width - 40);
     });
}

/**
 * Apply the css to the selected tab
 * and change the panel content
 */
function selectTab(tab) {
    var tabs = new Array();
    tabs = Ext.select('.ext-tab-selected');

    // Reset CSS
    for( i=0; i<tabs.getCount(); i++ ) {
        var el = tabs.item(i);
        el.replaceCls('ext-tab-selected', 'ext-tab-normal');
    }

    // Add new CSS
    Ext.get(tab.id).replaceCls('ext-tab-normal', 'ext-tab-selected');

    // Update tab content
    var curTab = Ext.get('currentTab');
    if (curTab.dom.innerHTML != '') {
        Ext.get(curTab.dom.innerHTML + 'Content').dom.style.display = 'none';
    }
    curTab.dom.innerHTML = tab.id;

    //var div = Ext.get('tabContent');
    var tab = Ext.get(tab.id + 'Content');
    if (tab) {
        tab.dom.style.display = 'block';
        resizeContentPanel();
        //div.dom.innerHTML = tab.dom.innerHTML;
    } else {
        //div.dom.innerHTML = "";
    }

}

function removeScheduledDowntime(el, hostId, serviceId, downtimeId, type, entryTime) {
    // Clean old windows
    var oWin = Ext.getCmp('extCmdWin');

    if (oWin) {
        oWin.close();
        Ext.get('cmdWin').dom.innerHTML = "";
    }

    var postBody = {};

    postBody.cmd        = el.id;
    postBody.host_id    = hostId;
    postBody.service_id = serviceId;
    postBody.option     = 0;
    postBody.sched_downtime_id   = downtimeId;
    postBody.sched_downtime_type = type;
    postBody.sched_entry_time    = entryTime;
    postBody.elements = '["' + hostId + ((serviceId) ? "!" + serviceId + '"]' : '"]');

    Ext.Ajax.useDefaultXhrHeader = true;
    var win = Ext.create('Ext.window.Window', {
        width: 420,
        layout: 'fit',
        overflowY: 'auto',
        id: 'extCmdWin',
        closable: false,
        closeAction: 'destroy',
        manageHeight: true,
        y: 100,
        buttonAlign: 'center',
        plain: false,
        modal: true,
        draggable: false,
        shadow: false,
        bodyCssClass: 'ext-window',
        bodyBorder: false,
        hideBorders: true,
        resizable: false,
        loader: {
            url: '/opmon/seagull/www/index.php/extinfo/action/load_cmd_form/?',
            autoLoad: true,
            params: postBody,
            ajaxOptions: {
                disableCaching: false,
                method: 'POST'
            },
            callback: function(me, success, response) {
                renderDatetimePicker(me);
            },
            success: function(){
                win.center();
            }
        }
    });

    win.show();
    return;
}

function callCommandWindow( id, obj, tpl, option, isJson ) {
    // Clean old windows
    var oWin = Ext.getCmp('extCmdWin');

    if (oWin) {
        oWin.close();
        Ext.get('cmdWin').dom.innerHTML = "";
    }

    var json = (isJson) ? Ext.JSON.decode(id) : new Array();

    // Process parameters
    var id = String(id);
    var postBody = {};

    if (json.length) {
        postBody.elements = id;
    } else if (!id.match("_")) {
        postBody.host_id = id;
    } else if (id.match("hg_")) {
        var reg = /^hg_(.*)$/;
        var match = reg.exec(id);
        postBody.hostgroup_name = match[1];
    } else if (id.match("sg_")) {
        var reg = /^sg_(.*)$/;
        var match = reg.exec(id);
        postBody.servicegroup_name = match[1];
    } else {
        var reg = /(\d*)_(\d*)/;
        var match = reg.exec(id);
        postBody.host_id = match[1];
        postBody.service_id = match[2];
    }

    postBody.cmd = obj.id;
    postBody.option = option || 0;
    postBody.tpl = tpl || 0;

    Ext.Ajax.useDefaultXhrHeader = true;
    var win = Ext.create('Ext.window.Window', {
        width: 420,
        layout: 'fit',
        id: 'extCmdWin',
        closable: false,
        closeAction: 'destroy',
        manageHeight: true,
        y: 100,
        buttonAlign: 'center',
        plain: false,
        modal: true,
        draggable: false,
        shadow: false,
        bodyCssClass: 'ext-window',
        bodyBorder: false,
        hideBorders: true,
        resizable: false,
        loader: {
            url: '/opmon/seagull/www/index.php/extinfo/action/load_cmd_form/?',
            autoLoad: true,
            params: postBody,
            ajaxOptions: {
                disableCaching: false,
                method: 'POST'
            },
            callback: function(me, success, response) {
                renderDatetimePicker(me);
            },
            success: function(){
                win.center();
            }
        }
    });

    win.show();
    return;
}

/**
 * Toggle command status - Used to toggle id when user do a action on command service or command host screen
 */
function toggleCommandStatus(id) {
    if(id.match(/Enable|Disable/)) {
        var aux = id.match(/Enable/) ? {status: 'Enable', reverse: 'Disable'} : {status: 'Disable', reverse: 'Enable'};
        return id.split(aux.status).join(aux.reverse);
    }
    return null;
}

function parseDateTime(date, time) {
    return Ext.Date.parse(date.getSubmitValue() + " " + time.getSubmitValue(), "Y-m-d H:i:s");
}

/**
 * Validate date
 */

function validateCmdDateForm(compulsoryFields) {

    var d1, t1, d2, t2, d3, t3, dateTime1, dateTime2, cmp;
    var ids = compulsoryFields.dom.textContent.split(",");
    var cmd = undefined;
    var error = undefined;
    var errorMsg = '';

    try {
        cmd = Ext.query('[name=cmd]')[0].value;
    } catch (e) {
    }

	for (i = 0; i < ids.length; i++) {
        cmp = Ext.getCmp(ids[i]);
        if (! (cmp && cmp.xtype === 'datefield' || cmp.xtype === 'timefield')) {
            return false;
        }

        if (cmp.activeError || cmp.value === '') {
            return false;
        }

        if (cmp.xtype === 'datefield' && cmp.id === 'date_start_time') {
            d1 = cmp;
        }

        if (cmp.xtype === 'datefield' && cmp.id === 'date_end_time') {
            d2 = cmp;
        }

        if (cmp.xtype === 'datefield' && cmp.id === 'date_expire_time') {
            d3 = cmp;
        }

        if (cmp.xtype === 'timefield' && cmp.id === 'time_start_time') {
            t1 = cmp;
        }

        if (cmp.xtype === 'timefield' && cmp.id === 'time_end_time') {
            t2 = cmp;
        }

        if (cmp.xtype === 'timefield' && cmp.id === 'time_expire_time') {
            t3 = cmp;
        }
    }

    if (d3 && t3 && parseDateTime(d3, t3) < (new Date)) {
        Ext.MessageBox.show({
            width: 400,
            msg: t('Invalid Expiration Date/Time'),
            buttons: Ext.MessageBox.OK,
            icon: Ext.MessageBox.ERROR,
            cls: 'ext-window'
        });
        return false;
    }

    if (!d1 || !d2 || !t1 || !t2) {
        return true;
    }

    if (ids.length > 2) {
        dateTime1 = parseDateTime(d1, t1);
        dateTime2 = parseDateTime(d2, t2);

        if (cmd.match(/.*(AddSlaBreach|AddScheduled)/)) {
            if (dateTime2 > (new Date) && ! cmd.match(/.*AddScheduled/)) {
                error = 'end';
                errorMsg = t('The end date and end time must be less than now');
            } else if (dateTime1 >= dateTime2) {
                error = 'start';
                errorMsg = t('The start date must be less than the end date.');
            }
        }

        if (error) {
            endField = (error === 'end');

            Ext.MessageBox.show({
                width: 400,
                closable: false,
                msg: errorMsg,
                buttons: Ext.MessageBox.OK,
                icon: Ext.MessageBox.ERROR,
                cls: 'ext-window',
                fn: updateDateErrorFocus(endField)
            });
            return false;
        }
    }

    return true;
}

function updateDateErrorFocus(end) {
    if (end) {
        Ext.getCmp('date_end_time').focus();
        Ext.getCmp('date_end_time').setActiveError('');
    } else {
        Ext.getCmp('date_start_time').focus();
        Ext.getCmp('date_start_time').setActiveError('');
    }
}

/**
 * Submit command to OpMon
 */
function validateCmdForm() {
    var compulsoryFields = Ext.get('date_compulsory_fields');
    var expirationInput = document.querySelector('input[name="expiration"]');

    if (expirationInput && expirationInput.checked && compulsoryFields && (! validateCmdDateForm(compulsoryFields))) {
        return;
    }

    compulsoryFields = Ext.get('compulsory_fields');

    if (compulsoryFields) {
        var fields, cmp, element;

        if (compulsoryFields.dom.tagName === 'INPUT') {
            fields = compulsoryFields.dom.value.split(",");
        } else if (compulsoryFields.dom.tagName === 'TEXTAREA') { // ExtJS component
            fields = compulsoryFields.dom.textContent.split(",");
        } else {
            return;
        }

        for(var i = 0; i < fields.length; i++) {
            cmp = Ext.getCmp(fields[i]);

            var isValueEmptyEitherADateOrTimeFieldWithErrors =
            (
                cmp &&
                (
                    cmp.value == '' ||
                    (
                        cmp.activeError &&
                        (
                            cmp.xtype === 'datefield' ||
                            cmp.xtype === 'timefield'
                        )
                    )
                )
            );

            if (isValueEmptyEitherADateOrTimeFieldWithErrors) {
                cmp.addCls('invalid-field');
                cmp.focus();
                return;
            }

            element = Ext.get(fields[i]);
            if ((element.dom.tagName === 'INPUT' || element.dom.tagName === 'TEXTAREA')
                && (element.dom.value === '')
            ) {
                Ext.get(fields[i]).focus();
                return;
            }
        }
    }

    var form = Ext.get('cmdForm').dom;
    var id = form.querySelector('input[name="cmd"]').value;
    var newId = toggleCommandStatus(id);
    var elToChangeId = document.getElementById(id);

    if(elToChangeId && newId) {
        elToChangeId.id = newId;
    }

    form.submit();
}

/**
 * Cancel command window
 */
function cancelCommand() {
    var cmdForm = Ext.get('cmdForm');
    var win = Ext.getCmp('extCmdWin');

    if(cmdForm) {
        var elId = cmdForm.dom.elements[0].value;
        var el = document.getElementById(elId);
        if(el) {
            Ext.get('cmdWin').dom.innerHTML = "";
            el.checked = ! el.checked;
        }
    }

    if (win) {
        win.close();
    }
}

/**
 * Send submitted command
 * to be processed by OpMon
 */
function sendCommand() {
    // Get form elements
    var form = Ext.get('cmdForm').dom;

    var postElements = {};
    for( var i = 0; i<form.elements.length; i++ ) {
        var el = form.elements[i];
        if (! (el.type == 'checkbox' && ! el.checked) && el.name) {

            if (el.name.match(/.*-.*/)) {
                el.name = el.name.replace(/-.*/,"");
            }
            postElements[el.name] = el.value;
        }
    }

    if ((postElements.cmd === 'serviceRescheduleNextCheck') || (postElements.cmd === 'hostRescheduleNextCheck')) {
        postElements.check_time = postElements.date_check_time.replace(/([0-9]{4})-([0-9]{2})-([0-9]{2})/,"$3/$2/$1") + ' ' + postElements.time_check_time;
        delete postElements.date_check_time;
        delete postElements.time_check_time;
    } else if ((postElements.cmd === 'serviceAddScheduledDowntime') || (postElements.cmd === 'hostAddScheduledDowntime')) {
        postElements.start_time = postElements.date_start_time.replace(/([0-9]{4})-([0-9]{2})-([0-9]{2})/,"$3/$2/$1") + ' ' + postElements.time_start_time;
        postElements.end_time = postElements.date_end_time.replace(/([0-9]{4})-([0-9]{2})-([0-9]{2})/,"$3/$2/$1") + ' ' + postElements.time_end_time;
        delete postElements.date_start_time;
        delete postElements.time_start_time;
        delete postElements.date_end_time;
        delete postElements.time_end_time;
    } else if (postElements.cmd === 'serviceRemoveAcknowledgement') {
        var arr = [ postElements.host_id + '!' + postElements.service_id  ];

        if (postElements.host_id === undefined || postElements.service_id === undefined) {
            arr = Ext.JSON.decode(el.value);
        }
        postElements.arrElements = JSON.stringify(arr);

        delete postElements.host_id;
        delete postElements.service_id;
    }

    // Clean old form
    Ext.get('cmdWin').dom.innerHTML = "";

    // Submit request
    submitCommandoWithConfirmModal(postElements);
}

function submitCommandoWithConfirmModal(params) {
    var win = Ext.getCmp('extCmdWin');
    if (win) {
        win.close();
    }

    Ext.MessageBox.show({
        msg: langArray['Submiting command, please wait'] + ' ...',
        width: 350,
        wait: true,
        closable: false,
        waitConfig: { interval:200 },
        cls: 'ext-window'
    });

    return Ext.Ajax.request({
        url: '/opmon/seagull/www/index.php/extinfo/action/run_extinfo_commands/',
        method: 'post',
        params: params,
        success: function(result,request) {
            // Replace MessageBox
            Ext.MessageBox.close();
            Ext.MessageBox.show({
                width: 350,
                closable: false,
                msg: langArray['Command submitted successfully'],
                buttons: Ext.MessageBox.OK,
                icon: Ext.MessageBox.INFO,
                cls: 'ext-window',
                fn: updateByButton
            });
            setTimeout(function() {
                Ext.MessageBox.close();
            }, 1000);
        }
    });
}

function submitCmdNow(elements, cmd) {
    var now = new Date(Date.now());
    submitCommandoWithConfirmModal({
        forced_checked: 1,
        cmd: cmd,
        time: Math.floor(now.getTime() / 1000),
        arrElements: elements,
        check_time: Ext.Date.format(now, 'd/m/Y H:i:s')
    })
}

/**
 * Update all extinfo tabs
 */

function updateExtInfo() {
    var el = Ext.get('currentType');
    if (! el) {
        return;
    }

    var type = el.dom.innerHTML;
    var tabs = [ 'Info', 'Config', 'History' ];
    for( i = 0; i<tabs.length; i++ ) {
        var tab = tabs[i];
        requestTabUpdate(type, tab);
    }
}

/**
 * Request an update for on tab
 */

function requestTabUpdate( type, tab, icon) {
    if (tab === 'Config') {
        return false;
    }

    icon = Ext.get(icon);
    if (icon) {
        icon.dom.src = icon.dom.src.replace("refresh", "loading");
    }

    var ID = Ext.get('objID').dom.innerHTML;
    var URL = '/opmon/seagull/www/index.php/extinfo/action/update_' + type + '_screen/';

    Ext.Ajax.request({
        url: URL,
        method: 'post',
        params: {
            type: type,
            tab: tab,
            objID: ID
        },
        success: function(result,request) {
            var xTab = Ext.get('tab' + tab + 'Content');
            setTimeout(function(){
                if (! xTab) {
                    return true;
                }
                xTab.dom.innerHTML = result.responseText;
            }, 100);
        },
        failure: function() {
            if (icon) {
                icon.dom.src = icon.dom.src.replace("loading", "refresh");
            }
        }
    });
}

/**
 * Update tab after Messabox click
 */

function updateByButton( btnId, text ) {
    if (btnId != "ok") {
        return;
    }

    var el = Ext.get('currentType');
    if (el) {
        updateExtInfo( el.dom.innerHTML );
    }
}

function createScatPanel() {
    Ext.QuickTips.init();

    Ext.each( Ext.query('.scatPanel'), function(el) {

        var split = el.id.split("!");
        var scatId = split[0];
        var scatName = split[1];

        var aPanel = false;
        var tree = false;

        var scatString = '<a class="ext-link" style="color: #000;" href="/opmon/seagull/www/index.php/opsubscriber/action/scatsubscriber/scat_id/' + scatId + '">' + scatName + '</a>';

        //if (Ext.query('.inpactPanel').length === 0) {
            // Create Scat Panel
            var panel = new Ext.Panel({
                contentEl: el,
                renderTo: 'tabImpactContent',
                layout: 'fit',
                title: scatString,
                cls: 'inpactPanel',
                frame: false,
                collapsible: true,
                collapsed: true,
                ui: 'light',
                titleCollapse: false,
                header: {
                    style: {
                        backgroundColor: '#e9e9e9'
                    }
                },
                style: {
                    marginBottom: '10px'
                }
            });
        //}
        var elements;
        Ext.Ajax.request({
            url: '/opmon/seagull/www/index.php/extinfo/action/service_tree_layout/id/' + scatId,
            method: 'post',
            success: function(result, request) {
                elements = Ext.JSON.decode(result.responseText);
                var store = new Ext.create('Ext.data.TreeStore',{
                    root: {
                        draggable:false,
                        children: elements
                    }
                });

                // Create Scat Structure Tree
                Ext.each( Ext.query('.scatStructureTree',el), function(div) {
                    tree = new Ext.tree.TreePanel({
                        el: div,
                        useArrows: true,
                        autoScroll: true,
                        animate: true,
                        enableDD: false,
                        containerScroll: true,
                        rootVisible: false,
                        trackMouseOver: false,
                        width: (Ext.getBody().getWidth() - 83 - 380),
                        height: 170,
                        border: false,
                        selModel: false,
                        store: store
                    });

                    tree.getRootNode().expandChildren(true);
                    tree.addBodyCls('noBorderImpactTree');
                    tree.render();
                    scatMemoryMgr.push(tree);
                });
            }
        });
    });
}

var renderDatetimePicker = function(me) {

    Date.monthNames = [
        langArray["Jan"],
        langArray["Feb"],
        langArray["Mar"],
        langArray["Apr"],
        langArray["May"],
        langArray["Jun"],
        langArray["Jul"],
        langArray["Aug"],
        langArray["Sep"],
        langArray["Oct"],
        langArray["Nov"],
        langArray["Dec"]
    ];

    Date.dayNames = [
        langArray["Sunday"],
        langArray["Monday"],
        langArray["Tuesday"],
        langArray["Wednesday"],
        langArray["Thursday"],
        langArray["Friday"],
        langArray["Saturday"]
    ];
    if(Ext.DatePicker){
        Ext.apply(Ext.DatePicker.prototype, {
          todayText: langArray["Today"],
          monthNames: Date.monthNames,
          dayNames: Date.dayNames,
          cancelText: langArray["Cancel"]
        });
    }

    var objs = Ext.query('.datetime-picker');
    var ids, obj, form = new Array(), now = new Date(), dateTime;
    var hours;
    var cmd = undefined;


    try {
        cmd = Ext.query('[name=cmd]')[0].value;
    } catch (e) {
    }

    //Action can't have time greater than now
    var minTimeFieldValue = function(cmd, date){
        if (cmd == "hostAcknowledgeProblem" || cmd == "serviceAcknowledgeProblem" && date.getDate() == new Date().getDate()) {
            return Ext.Date.format(new Date(), 'H:i:s')
        }
        return '00:00:00';
    }

    for (i = 0; i < objs.length; i++) {
        obj = Ext.get(objs[i]);
        if (ids) {
            ids = ids + ',date_' + obj.id + ',time_' + obj.id;
        } else {
            ids = 'date_' + obj.id + ',time_' + obj.id;
        }

        if (obj.id === 'end_time') {
            dateTime = new Date(now.setHours(now.getHours() + 2));
            hours = getStringWithFormattedHours(dateTime.getHours(), dateTime.getMinutes());
            is_disabled = false;
        } else if (obj.id === 'expire_time') {
            dateTime = new Date(now.setHours(now.getHours() + 2));
            hours = getStringWithFormattedHours(dateTime.getHours(), dateTime.getMinutes());
            is_disabled = true;
        } else {
            var startTime = new Date();
            dateTime = startTime;
            hours = getStringWithFormattedHours(
                startTime.getHours(),
                startTime.getMinutes(),
                obj.id
            );
            is_disabled = false;
        }

        if (obj.dom) {
            obj.dom.innerHTML = "";
        }

        Ext.destroy(Ext.getCmp('date_'+ obj.id));
        Ext.destroy(Ext.getCmp('time_'+ obj.id));
        form[i] = new Ext.form.FormPanel({
            renderTo: obj.id,
            width: 225,
            layout: 'hbox',
            closeAction: 'destroy',
            items: [{
                xtype: 'datefield',
                margin: '0 2 0 2',
                width: 110,
                allowBlank: false,
                editable: false,
                anchor: '100%',
                cls: 'no-input-border',
                id: 'date_'+ obj.id,
                format: 'Y-m-d',
                listeners: {
                    change: function() {
                        if (Ext.getCmp('time_expire_time')) {
                            Ext.getCmp('time_expire_time').setMinValue(minTimeFieldValue(me.params.cmd, this.value));
                        }
                    }
                },
                value: dateTime,  // defaults to today
                disabled: is_disabled
            }, {
                xtype: 'timefield',
                width: 107,
                allowBlank: false,
                editable: true,
                id: 'time_' + obj.id,
                cls: 'no-input-border',
                minValue: minTimeFieldValue(me.params.cmd, new Date()),
                maxValue: '23:59:59',
                value: hours,
                increment: 15,
                format: 'H:i:s',
                anchor: '100%',
                disabled: is_disabled
            }]
        });

        if (obj.id === 'expire_time') {
            Ext.getCmp('date_'+ obj.id).setMinValue(new Date());
        }
    }

    if (objs.length > 0) {
        form[Number(form.length - 1)].add([
            {
                xtype: 'text',
                id: 'date_compulsory_fields',
                text: ids,
                hidden: true
            }
        ]);

        if (cmd.match(/.*AddSlaBreach/)) {
            processElementsOnSlaBreakReasonPopup();
        }
	}

}

function processElementsOnSlaBreakReasonPopup() {
    var isNotSlaBreakPopup = (Ext.get('PopupSlaBreackReason') == false);

    if (isNotSlaBreakPopup) {
        return false;
    }

    var now = new Date();
    var twoHoursAgo = new Date();
    twoHoursAgo.setHours(now.getHours() - 2);

    Ext.getCmp('date_start_time').setMaxValue(now);
    Ext.getCmp('time_start_time').setValue(twoHoursAgo);

    Ext.getCmp('date_end_time').setMaxValue(now);
    Ext.getCmp('time_end_time').setValue(now);
}


// Create the external commands combobox
function externalCommandsCombo() {
    var external_commands_store = Ext.create('Ext.data.Store', {
        fields: [
            'command_id',
            'command_name',
            'command_desc',
            'command_line',
            'user_can_execute_command'
        ],
        autoLoad: true,
        storeId: 'external_commands',
        proxy: {
            type: 'ajax',
            url: '/opmon/seagull/www/index.php/extinfo/action/getexternalcommands/',
            reader: {
                type: 'json'
            }
        }
    });

    Ext.create('Ext.panel.Panel', {
        id: 'ext-info-cell-command-panel',
        bodyPadding: 10,
        bodyStyle: {
            backgroundColor:'#ddd',
            color:'#222',
            fontFamily:'"Courier New", Courier, monospace'
        },
        style: {
            backgroundColor:'#fff'
        },
        margin: '10 0 0 0',
        height: 139,
        dockedItems: [
            {
                xtype: 'button'    ,
                dock: 'bottom',
                id: 'ext-info-cell-command-btn',
                text: t("Apply command"),
                hidden: true,
                margin: '5 0 0 0',
                handler: function(el, event) {
                    if (Ext.getStore('external_commands').getAt(0).get('user_can_execute_command')) {
                        getReasonPopup(el, event);
                    } else {
                        callCommandWindow(false, {id: false});
                    }
                }
            }
        ],
        renderTo: Ext.get('ext-info-cell-command')
    });

    Ext.create('Ext.form.ComboBox', {
        label: false,
        id: "ext-info-cell-combo",
        emptyText: t("Select or search an external command"),
        queryMode: 'local',
        width: 290,
        displayField: 'command_name',
        valueField: 'command_id',
        store: external_commands_store,
        renderTo: Ext.get("ext-info-cell-custom"),
        tpl: Ext.create('Ext.XTemplate',
            '<tpl for=".">',
            '<div class="x-boundlist-item">{command_name} - {command_desc}</div>',
            '</tpl>'
        ),
        displayTpl: Ext.create('Ext.XTemplate',
            '<tpl for=".">',
            '{command_name} - {command_desc}',
            '</tpl>'
        ),
        listeners: {
            change: {
                scope: this,
                fn: function(el, newValue, oldValue, eOpts) {
                    var value = el.getStore().findRecord('command_id', newValue).get('command_line');
                    Ext.getCmp('ext-info-cell-command-panel').update(value);
                    Ext.getCmp('ext-info-cell-command-btn').show();
                }
            }
        }

    });
}

// Set EventManager
Ext.EventManager.onDocumentReady( resizeContentPanel );
Ext.EventManager.onWindowResize( resizeContentPanel );

// eof

//external command result window
function resultWindow(cmd_exec_result) {
    cmd_exec_result = cmd_exec_result || {
        std_err: t("Fail to execute command"),
        std_out: "",
        success: false
    };

    Ext.create('Ext.window.Window', {
        renderTo: Ext.getBody(),
        height: Ext.getBody().getViewSize().height * 0.8,
        id: 'external_cmd_result_modal',
        closable: false,
        width: Ext.getBody().getViewSize().width * 0.8,
        layout: 'anchor',
        title: t("External command was executed"),
        modal: true,
        closeAction: 'destroy',
        manageHeight: true,
        y: 100,
        plain: false,
        draggable: true,
        shadow: false,
        bodyCssClass: 'ext-window',
        bodyBorder: false,
        autoScroll: true,
        hideBorders: true,
        resizable: true,
        items: [
            {
                xtype: 'form',
                id: 'ext_res_form',
                autoScroll: true,
                bodyPadding: '15 20 20',
                header: false,
                title: 'My Form',
                layout: {
                    type: 'vbox',
                    align: 'stretch'
                },
                items: [
                    {
                        xtype: 'displayfield',
                        id: 'cmd_name',
                        fieldLabel: t("Command executed"),
                        labelAlign: 'top',
                        value: Ext.getCmp('ext-info-cell-combo').getDisplayValue(),
                        fieldStyle: 'font-weight: bold;'
                    },
                    {
                        xtype: 'displayfield',
                        id: 'success_log',
                        margin: '10 0',
                        fieldLabel: t("Success log"),
                        labelAlign: 'top',
                        hidden: true,
                        htmlEncode: false,
                        value: cmd_exec_result.std_out,
                        fieldStyle: 'background-color: #333; color: #fff; padding: 15px; border-left: 6px solid green;',
                        listeners : {
                            afterrender: {
                                fn : function(this_obj) {
                                    setTimeout(function(){
                                        this_obj.show();
                                        if ( ! cmd_exec_result.success) {
                                            Ext.getCmp('external_cmd_result_modal').setTitle(langArray["External command cannot be executed"]);
                                            Ext.getCmp('success_log').hide();
                                        }
                                        if (cmd_exec_result.std_out === '') {
                                            Ext.getCmp('success_log').hide();
                                        }
                                    }, 100);
                                }
                            }
                        },
                    },
                    {
                        xtype: 'displayfield',
                        id: 'fail_log',
                        margin: '10 0 0 0',
                        fieldLabel: t("Fail log"),
                        labelAlign: 'top',
                        hidden: true,
                        htmlEncode: false,
                        value: cmd_exec_result.std_err,
                        listeners : {
                            afterrender: {
                                fn : function(this_obj) {
                                    setTimeout(function(){
                                        this_obj.show();
                                        if (cmd_exec_result.std_err === '') {
                                            Ext.getCmp('fail_log').hide();
                                        }
                                    }, 100);
                                }
                            }
                       },
                       fieldStyle: 'background-color:#333; color: #fff; padding: 15px; border-left: 6px solid red;'
                    }
                ]
            }
        ],
        dockedItems: [
            {
                xtype: 'toolbar',
                dock: 'bottom',
                items: [
                    {
                        xtype: 'tbspacer',
                        flex: 1
                    },
                    {
                        xtype: 'button',
                        id: 'retry_btn',
                        text: t("Retry"),
                        handler: function (el, event) {
                            do_request(el, event);
                            Ext.getCmp('external_cmd_result_modal').destroy();
                        }
                    },
                    {
                        xtype: 'container',
                        items: [
                            {
                                xtype: 'button',
                                id: 'ok_btn',
                                width: 100,
                                text: t('OK'),
                                handler: function() {
                                    Ext.getCmp('external_cmd_result_modal').destroy();
                                    Ext.getCmp('reason_popup').destroy();
                                }
                            }
                        ]
                    }
                ]
            }
        ]
    }).show();
}

function getReasonPopup() {
    Ext.create('Ext.window.Window', {
        renderTo: Ext.getBody(),
        draggable: false,
        height: 250,
        width: 400,
        resizable: true,
        closeAction: 'destroy',
        manageHeight: true,
        y: 100,
        plain: false,
        draggable: false,
        shadow: false,
        bodyCssClass: 'ext-window',
        bodyBorder: false,
        hideBorders: true,
        title: t("Execute an external command"),
        modal: true,
        id: "reason_popup",

        layout: {
            type: 'vbox',
            align: 'stretch'
        },

        items: [
            {
                xtype: 'form',
                flex: 1,
                bodyPadding: '15 20 20',
                header: false,
                title: 'My Form',
                items: [
                    {
                        xtype: 'textareafield',
                        validator: function(value) {
                            errMsg = t("You have to write a reason");
                            if (value === '') {
                                Ext.getCmp('submit_externalcmd').setDisabled(true);
                            } else {
                                Ext.getCmp('submit_externalcmd').setDisabled(false);
                            }
                            return (value === '') ? errMsg : true;
                        },
                        anchor: '100%',
                        fieldLabel: t("Write your reasons"),
                        labelAlign: 'top',
                        id: 'reason_area',
                        rows: 7
                    }
                ]
            }
        ],
        dockedItems: [
            {
                xtype: 'toolbar',
                dock: 'bottom',
                items: [
                    {
                        xtype: 'tbspacer',
                        flex: 1
                    },
                    {
                        xtype: 'button',
                        text: t("Cancel"),
                        handler: function (el, event) {
                            Ext.getCmp('reason_popup').destroy();
                        }
                    },
                    {
                        xtype: 'container',
                        items: [
                            {
                                xtype: 'button',
                                id: 'submit_externalcmd',
                                text: t("Confirm command execution"),
                                handler: do_request
                            }
                        ]
                    }
                ]
            }
        ]

    }).show();
}

function do_request(el, event) {
    var host_id = tHostId;
    var reason = Ext.getCmp('reason_area').getValue();
    var command_id = Ext.getCmp('ext-info-cell-combo').getValue();

    var mask = new Ext.LoadMask(Ext.getBody(), {msg:t("Please wait...")});
    mask.show();
    Ext.Ajax.request({
        url: "/opmon/seagull/www/index.php/extinfo/action/runexternalcommand/",
        method: "POST",
        timeout: 65000,
        params: {
            'host_id': host_id,
            'reason': reason,
            'command_id': command_id
        },
        success: function(result, request) {
            mask.destroy();
            var response = JSON.parse(result.responseText.replace(/\\n/g, '<br>'));
            resultWindow(response);
        },

        failure: function(result, request) {
            mask.destroy();
            resultWindow();
        }

    });
    Ext.getCmp('reason_popup').hide();
}


// Creating scope variable to stop polluting the global scope

var extinfo = {};


extinfo [ "scheduleDownTime" ] =
    ( function () {
        var toggle =
            function (status) {
				return function (id) {
					document.getElementById(id).style.display = status;
                };
            };

        var show = toggle ("block")
        var hidden = toggle ("none")

        function changeType (ev) {
			var val = ev.currentTarget.value;
            var other = val === "1" ? "0" : "1";
            var actions =
                { "0": [ "flexible"]
                , "1": [ "fixed" ]
                };

			if (val == 0 ) {
                (actions [other] || []).forEach (show);
				(actions [val] || []).forEach (show);
				return;
			}

			(actions [val] || []).forEach (show);
            (actions [other] || []).forEach (hidden);
		}

	        return { changeType: changeType };
    }) ()


extinfo [ "pluginOutput" ] =
    ( function () {
        var Frame = function (x) {
            return {
                map: function (f) {
                    f (x);
                    return Frame(x);
                }
            }
        }

        var getFrame = function (id) {
            return Frame(document.getElementById(id || "frame_long_plugin_output"));
        }

        var getChildren = function (frame) {
            return extinfo.Support.pluck(
                [ "contentWindow", "document", "body", "firstChild" ],
                frame
            );
        }

        var updateHeight = function (frame) {
            frame.style.minHeight = '400px';
        }

        var integrateCss = function (frame) {
            var styles = extinfo.Support.pluck(
                ["contentWindow", "document", "body", "firstChild", "style"],
                frame
            );

            if (styles) {
                styles.fontSize = "13px";
                styles.fontFamily = "helvetica, arial, verdana, sans-serif";
            }
        }

        var echoOutput = function (msg) {
            return function (frame) {
                frame.contentWindow.document.write (msg);
            }
        }

        var setFrameOutput = function (output) {
            getFrame()
                .map(echoOutput (output))
                .map(integrateCss)
                .map(updateHeight)
        }

        return {
            setFrameOutput: setFrameOutput
        };

    }) ()


extinfo [ "Support" ] =
    ( function () {
        var pluck = function (xs, init) {
            return xs.reduce(function (o, key) {
                    if (o && o [key]) {
                        return o [key]
                    }
                    return null;
                },
                init
            );
        }

        return { pluck: pluck }
    }) ()
