var CP_DATA = AVAIL_ALERT_DATA = undefined;
var divDecoder = document.createElement('div');
divDecoder.type = 'hidden';

function decodeHtmlCharacters(text) {
	divDecoder.innerHTML = text;
	return divDecoder.innerHTML;
}

function renderAvailGraphic(chartData, obj) {
	var nodata = false, colors = new Array();

	if (chartData === undefined) {
		chartData = new Object();
		chartData.avail = new Array();
		nodata = true;

		chartData.avail.push({'status':'','pct': ''});
		chartData.avail.push({'status':'','pct': ''});
		chartData.avail.push({'status':'','pct': ''});
		chartData.avail.push({'status':'','pct': ''});
	}

	// host and host group
	if ((obj.objectType === 0) || (obj.objectType === 2)) {
		if (chartData.avail.length >= 4) {
			// remove warning data
			chartData.avail[1] = chartData.avail[2];
			chartData.avail[2] = chartData.avail[3];
			chartData.avail.pop();
		}

		chartData.avail[0].status = decodeHtmlCharacters(obj.oklegend);
		chartData.avail[1].status = decodeHtmlCharacters(obj.criticallegend);
		chartData.avail[2].status = decodeHtmlCharacters(obj.unknownlegend);

	// service and service group
	} else if ((obj.objectType === 1) || (obj.objectType === 3)) {
		chartData.avail[0].status = decodeHtmlCharacters(obj.oklegend);
		chartData.avail[1].status = decodeHtmlCharacters(obj.warninglegend);
		chartData.avail[2].status = decodeHtmlCharacters(obj.criticallegend);
		chartData.avail[3].status = decodeHtmlCharacters(obj.unknownlegend);
	}

	// service and service group
	if ((obj.objectType === 1) || (obj.objectType === 3)) {
		colors			=	['#5DBC5E', '#F1CD5D', '#E64747', '#B2B2B2'];
	// host and host group
	} else if ((obj.objectType === 0) || (obj.objectType === 2)) {
		colors			=	['#5DBC5E', '#E64747', '#B2B2B2'];
	}

	for(i=0; i < chartData.avail.length; i++) {
		chartData.avail[i].pct = parseInt(chartData.avail[i].pct).toFixed(2);
	}

	AmCharts.makeChart("availGraphic", {
		"type":					"pie"
		,"theme":				"none"
		,"dataProvider":		chartData.avail
		,"titleField":			"status"
		,"valueField":			"pct"
		,"outlineColor":		"#FFFFFF"
		,"colors":				colors
		,"labelText":			'[[percents]]%'
		,"outlineThickness":	2
		,"startDuration":		0
		,"pullOutRadius":		0
		,"balloonText":			'[[title]]: [[percents]]% '
		,"labelRadius":			10
		,"labelsEnabled":		false
		,"legend": {
			"maxColumns": 		1,
			"align":			"left"
			,"markerSize":		10
			,"labelText":		'[[title]]'
			,"valueText":		'[[value]]%'
			,"autoMargins":		false
			,"verticalGap":		0
			,"switchable":		false
			,"divId":			"availGraphicLegend"
			,"equalWidths":		true
		}
	});

	if (nodata === true) showNodataInfo('availGraphic', 60);
}

function renderGraphic(data, gType) {
	if (gType === 'cp') {
		Ext.get('performanceGraphic').dom.innerHTML = '';
		renderCPGraphic(data, true, 'performanceGraphic');
	} else if (gType === 'alert') {
		Ext.get('alertGraphic').destroy();
		Ext.DomHelper.append('alertGraphicBlock','<div id="alertGraphic" style="width: 100%; height: 140px; display: block; float: left;"></div>');

		renderAlertGraphic(data, false);
	}
}

function constructGraphic(obj, gType, dom_id, icon, use_legend) {
	if ((dom_id === undefined) && (gType === "cp")) {
		return;
	}

	var url;
	icon = Ext.get(icon);
	if (icon) icon.dom.src = icon.dom.src.replace("refresh", "loading");
	use_legend = (use_legend === undefined) ? true : use_legend;

	if ((gType === 'avail') || (gType === 'alert')) {
		url = '/opmon/seagull/www/index.php/wsconnector/action/getavail';
	} else if (gType === 'cp') {
		url = '/opmon/seagull/www/index.php/wsconnector/action/getcp';
	}

    if (Ext.Ajax.setUseDefaultXhrHeader) {
        Ext.Ajax.setUseDefaultXhrHeader(false);
    } else {
        Ext.Ajax.useDefaultXhrHeader = false;
    }
	Ext.Ajax.request({
		url: url,
		method:	'post',
		params: {jsonData: Ext.JSON.encode(obj)},
		success: function(result) {
			if (gType === 'cp') {
				CP_DATA = Ext.JSON.decode(result.responseText)[0];
				renderCPGraphic(CP_DATA, use_legend, dom_id);
			} else if ((gType === 'alert') || (gType === 'avail')) {
				// host
				if (obj.objectType === 0) {
					AVAIL_ALERT_DATA = Ext.JSON.decode(result.responseText)[0];
					if (AVAIL_ALERT_DATA !== undefined) AVAIL_ALERT_DATA[1] = Ext.JSON.decode(result.responseText)[1];
					AVAIL_ALERT_DATA = extractGraphData(AVAIL_ALERT_DATA, 'host');
				// service
				} else if (obj.objectType === 1) {
					AVAIL_ALERT_DATA = Ext.JSON.decode(result.responseText)[0];
					AVAIL_ALERT_DATA = extractGraphData(AVAIL_ALERT_DATA, 'service');
				// host group
				} else if (obj.objectType === 2) {
					AVAIL_ALERT_DATA = Ext.JSON.decode(result.responseText);
					AVAIL_ALERT_DATA = extractGraphData(AVAIL_ALERT_DATA, 'hostgroup');
				// service group
				} else if (obj.objectType === 3) {
					AVAIL_ALERT_DATA = Ext.JSON.decode(result.responseText);
					AVAIL_ALERT_DATA = extractGraphData(AVAIL_ALERT_DATA, 'servicegroup');
				}

				renderAlertGraphic(AVAIL_ALERT_DATA, true);
				renderAvailGraphic(AVAIL_ALERT_DATA, obj);

				if (obj.objectType !== 1) renderIncidentsGraphic(AVAIL_ALERT_DATA, obj);
			}
			if (icon) { icon.dom.src = icon.dom.src.replace("loading", "refresh"); }
		},
		failure: function() {
			if (icon) icon.dom.src = icon.dom.src.replace("loading", "refresh");
		}
	});
    if (Ext.Ajax.setUseDefaultXhrHeader) {
        Ext.Ajax.setUseDefaultXhrHeader(true);
    } else {
        Ext.Ajax.useDefaultXhrHeader = true;
    }
}

function renderIncidentsGraphic(data, obj) {
	var nodata = false;

	if (data === undefined) {
		data			= new Object();
		data.incidents	= new Array();

		data.incidents.push({'pct': ''});
		data.incidents.push({'pct': ''});
		nodata			= true;
	} else if (data.incidents[0].pct === false) {
		nodata = true;
	}

	data.incidents[0].desc = decodeHtmlCharacters(obj.withacklegend);
	data.incidents[1].desc = decodeHtmlCharacters(obj.withoutacklegend);

	AmCharts.makeChart("incidentsGraphic", {
		"type":					"pie"
		,"innerRadius":			35
		,"theme":				"none"
		,"dataProvider":		data.incidents
		,"titleField":			"desc"
		,"valueField":			"pct"
		,"outlineColor":		"#FFFFFF"
		,"colors":				["#5687C1", "#DDDDDD"]
		,"labelText":			'[[percents]]%'
		,"outlineThickness":	2
		,"startDuration":		0
		,"pullOutRadius":		0
		,"balloonText":			''
		,"labelRadius":			10
		,"legend": {
			"align":			"left"
			,"markerSize":		10
			,"labelText":		'[[title]]'
			,"valueText":		''
			,"autoMargins":		false
			,"verticalGap":		0
			,"switchable":		false
			,"divId":			"incidentsGraphicLegend"
		}
	});

	if (nodata === true) {
		showNodataInfo('incidentsGraphic', 60);
		return;
	}
}

function timestamp2Date(date) {
	var dt = new Date(date * 1000);

	date = ((dt.getHours() < 10)?"0":"") + dt.getHours() +":"+ ((dt.getMinutes() < 10)?"0":"") + dt.getMinutes();
	dt = null;

	return date;
}

function createCPGraphicsObjs(data) {
	var i, g, graphics = new Array(), metrics = Object.keys(data.cpdata[0]);

	for (i=0; i < metrics.length; i++) {
		if (metrics[i] === "date") {
			continue;
		}

		g = new Object();

		g.id = 'g' + i;
		g.balloonText = "<span class='amCharts-balloon'>" + metrics[i] + ": [[value]] " + data.unit[i-1] + "</span>";
		g.valueField = metrics[i];
		g.useLineColorForBulletBorder = true;
		g.title = decodeHtmlCharacters(metrics[i]);
		g.fillAlphas = (i == 1) ? 0.2 : 0;
		graphics.push(g);

		g = null;
	}

	return graphics;
}

function renderCPGraphic(data, use_legend, dom_id) {
	if ((data === undefined) || (data.cpdata.length === 0)) {
		//showNodataInfo('performanceGraphic', 100);
		showNodataInfo(dom_id, 100);
		return;
	}

	if (!String(data.cpdata[0].date).match(/[0-9]{2}:[0-9]{2}/)) {
		for (i=0; i < data.cpdata.length; i++) {
			data.cpdata[i].date = timestamp2Date(data.cpdata[i].date);
		}
	}

	var legend = {
		"equalWidths":			true
		,"textClickEnabled":	true
		,"color":				"#000000"
		,"useGraphSettings":	false
		,"valueAlign":			"left"
		,"markerSize":			13
	}

	var cp_colors = new Colors();
	var graphics = createCPGraphicsObjs(data);
	AmCharts.makeChart(dom_id, {
		"type":				"serial"
		,"theme":			"none"
		,"dataProvider":	data.cpdata
		,"graphs":			graphics
		,'colors':			cp_colors.getCPColors()
		,"categoryField":	"date"
		,"fontFamily":		"Helvetica Neue, HelveticaNeue, Helvetica, Tahoma, Arial, Lucida Grande, sans-serif"
		,"fontSize":		10
		,"categoryAxis": {
			"gridThickness":	0.2
			,"gridAlpha":		0.3
			,"fillAlpha":		0
			,"fillColor":		"#FAFAFA"
			,"dashLength":		3
		}
		,"chartCursor": {
			"categoryBalloonEnabled":	true
			,"zoomable":				true
			,"cursorAlpha":				0.5
			,"cursorPosition":			"mouse"
		}
		,"valueAxes": [{
			"gridThickness":	0.3
			,"gridAlpha":		0.5
			,"dashLength":		3
		}]
		,"balloon": {
			"borderThickness":		1
			,"fillAlpha":			0.9
			,"cornerRadius":		1
			,"adjustBorderColor":	true
			,"color":				"#000000"
			,"textShadowColor":		"#00FF00"
		}
		, "legend": (use_legend) ? legend : ""
	});
}

function formatAlertData(data) {
	var alertData = new Array();

	for (var i in data) {
		alertData.push({"hour":data[i].label.replace(/.* /,""), "alerts": data[i].total});
	}

	return alertData;
}

function extractGraphData(data, objectType) {
	if ((data === undefined)
		|| ((objectType === 'servicegroup' || objectType === 'hostgroup') && (data[data.length - 1].incidents === undefined))) return;

	var newData = new Object();

	newData.alerts		= new Array();
	newData.avail		= new Array();
	newData.incidents	= new Array();

	if ((objectType === 'host')) {
		newData.incidents[0]	= { 'pct': data[1].incidents.with_ack };
		newData.incidents[1]	= { 'pct': data[1].incidents.without_ack };
	// service group
	} else if (objectType === 'servicegroup' || objectType === 'hostgroup') {
		data.incidents = data[data.length - 1].incidents;
		newData.incidents[0]	= { 'pct': data.incidents.with_ack };
		newData.incidents[1]	= { 'pct': data.incidents.without_ack };
		data.pop();
	}

	newData.avail[0] = { "status": "ok",	  "pct": 0 };
	newData.avail[1] = { "status": "warning", "pct": 0 };
	newData.avail[2] = { "status": "critical","pct": 0 };
	newData.avail[3] = { "status": "unknown", "pct": 0 };

	if (data.length === undefined) data = [data];
	newData.period = data[0].period.replace(/(\(|\))/g,"").replace(/->/,langArray["to"]);

	for (var i=0; i < data.length; i++) {
		for (var j in data[i].alerts) {
			if (newData.alerts[data[i].alerts[j].label] === undefined) {
				newData.alerts[data[i].alerts[j].label] = new Object();
				newData.alerts[data[i].alerts[j].label].total = 0;
				newData.alerts[data[i].alerts[j].label].label = data[i].alerts[j].label;
			}
			newData.alerts[data[i].alerts[j].label].total += Number(data[i].alerts[j].total);
		}
		newData.avail[0].pct	+= Number(data[i].ok_pct);
		newData.avail[1].pct	+= Number(data[i].warning_pct);
		newData.avail[2].pct	+= Number(data[i].critical_pct);
		newData.avail[3].pct	+= Number(data[i].unknown_pct);
	}

	newData.avail[0].pct	/= data.length;
	newData.avail[1].pct	/= data.length;
	newData.avail[2].pct	/= data.length;
	newData.avail[3].pct	/= data.length;

	newData.alerts = formatAlertData(newData.alerts);

	return newData;
}

function showNodataInfo(id, marginTop) {
	Ext.get(id).dom.innerHTML = '';
	Ext.DomHelper.append(id,'<div class="extinfo-graphic-nodata" style="margin-top: ' + marginTop + '">' + langArray[ 'No data available' ] + '</div>');
}

function renderAlertGraphic(data, updatePageTitle) {
	if (data === undefined) {
		showNodataInfo('alertGraphic', 60);
		return;
	}

	if (updatePageTitle === true) {
		var title	= Ext.get('periodInfo');
		var text	= title.dom.innerHTML.replace(/ - .*/,"") + ' - ' + data.period;
		title.dom.innerHTML = text;
	}

	AmCharts.makeChart("alertGraphic", {
		"type":				"serial"
		,"theme":			"none"
		,"dataProvider":	data.alerts
		,"categoryField":	"hour"
		,"fontFamily":		"Helvetica Neue, HelveticaNeue, Helvetica, Tahoma, Arial, Lucida Grande, sans-serif"
		,"fontSize":		10
		,"colors":			[ "#FFBC6C" ]
		,"graphs": [{
			"type":			"column"
			,"valueField":	"alerts"
			,"fillAlphas":	1
			,"lineAlpha":	0
		}]
		,"categoryAxis": {
			"gridThickness":	0.2
			,"labelRotation":	45
			,"gridAlpha":		0.3
			,"fillAlpha":		0
			,"fillColor":		"#FAFAFA"
			,"dashLength":		3
		}
		,"valueAxes": [{
			"gridThickness":	0.3
			,"gridAlpha":		0.5
			,"dashLength":		3
		}]
		,"chartCursor": {
			"categoryBalloonEnabled":	true
			,"zoomable":				true
			,"cursorPosition":			"mouse"
		}
		,"balloon": {
			"borderThickness":		1
			,"fillAlpha":			0.9
			,"cornerRadius":		1
			,"adjustBorderColor":	true
		}
	});
}
